<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qtcreator-api.qdoc -->
  <title>Common Extension Tasks | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Common Extension Tasks</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar"><div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Common Extension Tasks</h1>
<span class="subtitle"></span>
<!-- $$$common_extension_tasks.html-description -->
<div class="descr"> <a name="details"></a>
<p>This section summarizes the API functions that you can use to add UI components to Qt Creator.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Task</th><th >Details</th><th >API</th></tr></thead>
<tr valign="top" class="odd"><td >Add a menu or menu item.</td><td >You can extend existing menus or create new ones.</td><td >Core::ActionManager, Core::Command</td></tr>
<tr valign="top" class="even"><td >Add a configurable keyboard shortcut.</td><td >Registering shortcuts makes it possible for users to configure them in the common shortcut settings dialog.</td><td >Core::ActionManager, Core::Command</td></tr>
<tr valign="top" class="odd"><td >Add a mode.</td><td >Modes correspond to complete screens of controls, specialized for a task.</td><td >Core::IMode</td></tr>
<tr valign="top" class="even"><td >Add a new editor type.</td><td >Such as an editor for XML files.</td><td >Core::IEditorFactory, Core::IEditor, Core::IDocument</td></tr>
<tr valign="top" class="odd"><td >Add a new wizard.</td><td >You can extend the wizards in File &gt; New File or Project with your own file and project templates.</td><td >Core::IWizard, Core::StandardFileWizard, Core::BaseFileWizard, Core::BaseFileWizardParameters</td></tr>
<tr valign="top" class="even"><td >Add support for a new version control system.</td><td >Version control systems integrated in Qt Creator are Bazaar, CVS, Git, Mecurial, Perforce, and Subversion.</td><td >Core::IVersionControl</td></tr>
<tr valign="top" class="odd"><td >Add a view to the navigation sidebar.</td><td >The one which shows the project tree, filesystem, open documents or bookmarks.</td><td >Core::INavigationWidgetFactory</td></tr>
<tr valign="top" class="even"><td >Add an options page to the <b>Options</b> dialog.</td><td >Add a new page to existing or new category in <b>Tools</b> &gt; <b>Options</b>.</td><td >Core::IOptionsPage</td></tr>
<tr valign="top" class="odd"><td >Add a find filter to the <b>Find</b> dialog.</td><td >Implement any kind of search term based search.</td><td >Find::IFindFilter, Core::SearchResultWindow</td></tr>
<tr valign="top" class="even"><td >Add support for the find tool bar to a widget.</td><td >The widget that has focus is asked whether it supports text search. You can add support for widgets under your control.</td><td >Core::IFindSupport, Find::BaseTextFind</td></tr>
<tr valign="top" class="odd"><td >Add a completely new project type.</td><td ></td><td ></td></tr>
<tr valign="top" class="even"><td >Add a new type of build step.</td><td ></td><td ></td></tr>
<tr valign="top" class="odd"><td >Add a new filter to the locator.</td><td >For a text typed in by the user you provide a list of things to show in the popup. When the user selects an entry you are requested to do whatever you want.</td><td >Core::ILocatorFilter, Core::LocatorFilterEntry, Locator::BaseFileFilter</td></tr>
<tr valign="top" class="even"><td >Show a progress indicator for a concurrently running task.</td><td >You can show a progress indicator for your tasks in the left hand tool bar, and also in the application icon (on platforms that support it).</td><td >Core::ProgressManager, Core::FutureProgress</td></tr>
<tr valign="top" class="odd"><td ></td><td ></td><td ></td></tr>
</table></div>
</div>
<!-- @@@common_extension_tasks.html -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
